#!/usr/bin/env python2.5
execfile('/Users/ben/scripts/paths.py')
import os, sys, shutil
import commands

AUDIOGUIDE_DIR = '/Users/ben/Documents/audioGuide/'
AUDIOGUIDE_SCORE = '/Users/ben/Desktop/ag-vid-tests/doggyScore.txt'
AUDIOGUIDE_SF = '/Users/ben/Desktop/ag-vid-tests/doggyScore.aiff'
TMP_DIR = '/tmp'
OUTPUT = os.path.join(AUDIOGUIDE_DIR, 'output/output.mov')
VIDEO_FRAME_MIX_METHOD = 'mostRecentSegment' # 'composite' || 'lighten' || 'overlay' || 'mostRecentSegment'
NORMALIZE_TARGET_AUDIO = False
AUDIO_MIX_METHOD = 'targetAndResult' # 'target' || 'result' || 'targetAndResult'


[sr, bits, channels, isWave, duration] =  getSfInfo(AUDIOGUIDE_SF)
VIDEO_EXTENSION = '.mov'
FRAME_EXTENSION = '.jpg'
SR = int(sr)
FR = 24
DURATION_SEC = float(duration)
FADE_IN_FRAMES = 1
FADE_OUT_FRAMES = 1
USE_TARGET_VID = False
SILENCE_FRAM_START = 20 # where to start in vid
SILENCE_FRAME_ADVANCE = 0.25

def second2Frame(second):
	return int(second*FR)

def makeFrames(videoFilePath, frameDir, isTgt=False):
	global targetSize
	if not os.path.exists(frameDir):
		print "Decomposing", videoFilePath, "into frames..."
		os.makedirs(frameDir)
		#executeCommand('ffmpeg -qscale 1 -i '+videoFilePath+' -r '+str(FR)+' -f image2 -vcodec mjpeg -qscale 1 -s  '+targetSize+' '+frameDir+'/%d'+FRAME_EXTENSION)
		executeCommand('ffmpeg -qscale 1 -i '+videoFilePath+' -r '+str(FR)+' -f image2 -vcodec mjpeg -qscale 1 '+frameDir+'/%d'+FRAME_EXTENSION)
#	if not isTgt:
#		status, srcSize = commands.getstatusoutput("identify -format '%wx%h' "+ frameDir+'/1.jpg')
#		if targetSize != srcSize:
#			print "Rescaling Source Frames %s to match the Target size (%s->%s) ..."%(frameDir, srcSize, targetSize)
#			for f in os.listdir(frameDir):
#				fp = os.path.join(frameDir, f)
#				command = 'convert %s -resize %s\! %s'%(fp, targetSize, fp)
#				executeCommand(command)
#		sys.exit()

def findAssociatedVideoFile(soundfile):
	possibleExt = ['mov', 'mp4', 'wmv', 'avi', 'mpg']
	noExt = os.path.splitext(soundfile)[0]
	file = None
	for ext in possibleExt:
		file = noExt+'.'+ext
		if os.path.exists(file): break
	return file

# read the csound score of the last concatentation.
score = open(AUDIOGUIDE_SCORE, 'r')
scoreLines = score.readlines()
score.close()

# make a dict which holds what vids we need based on which corpus files are used in the score.
loadedVids = {}
durationFrames = int(DURATION_SEC*FR)
selectedFrames = {}
for i in range(1, durationFrames): # init it
	selectedFrames[i] = {'frames': [], 'fades': []}


targetPath = scoreLines[0].split()[0][1:]
if USE_TARGET_VID:
	targetVideoFilePath = findAssociatedVideoFile(targetPath)
	tgtFrameDir = os.path.join(os.path.splitext(targetPath)[0]+'-frames')
	makeFrames(targetVideoFilePath, tgtFrameDir, isTgt=True)
	n, targetSize = commands.getstatusoutput("identify -format '%wx%h' "+ tgtFrameDir+'/1.jpg')
	for i in range(1, durationFrames): # add target vid to each frame
		selectedFrames[i]['frames'].append((i, tgtFrameDir))
		selectedFrames[i]['fades'].append(1)

score = []
bclock = 0.0
minStartTime = sys.maxint	
for line in scoreLines:
	if line[0] == ";": continue
	line = line.split()
	if line[0] in ['b', 'B']:
		bclock = float(line[1])
		continue
	startTime = float(line[1])+bclock
	if startTime < minStartTime: minStartTime = startTime
	duration = float(line[2])
	sourceStartTime = float(line[5])
	soundFilePath = line[4].replace('"','')
	score.append([startTime, duration, sourceStartTime, soundFilePath])

# subtract min start time
#for sidx in range(len(score)): score[sidx][0] -= minStartTime
	
for startTime, duration, sourceStartTime, soundFilePath in score:
	videoFilePath = findAssociatedVideoFile(soundFilePath)
	if videoFilePath == None:
		print "VIDEO FOR SOUNDFILE NOT FOUND:", soundFilePath
		sys.exit()
	frameDir = os.path.join(os.path.splitext(soundFilePath)[0]+'-frames')
	makeFrames(videoFilePath, frameDir)
	startFrame = second2Frame(startTime) - FADE_IN_FRAMES
	durationFrame = second2Frame(duration) + FADE_OUT_FRAMES
	sourceStartFrame = second2Frame(sourceStartTime) - FADE_IN_FRAMES
	
	for frame in range(sourceStartFrame, sourceStartFrame+durationFrame):
		if startFrame < 1: continue
		fromStart = frame-sourceStartFrame
		fromEnd = (sourceStartFrame+durationFrame)-frame-1
		
		if fromStart < FADE_IN_FRAMES: fade = (fromStart+1)/(float(FADE_IN_FRAMES+1))
		elif fromEnd < FADE_OUT_FRAMES: fade = (fromEnd+1)/(float(FADE_OUT_FRAMES+1))
		else: fade = 1
		if not selectedFrames.has_key(startFrame):
			selectedFrames[startFrame] = {'frames': [], 'fades': []}
		selectedFrames[startFrame]['frames'].append((frame, frameDir, startTime))
		selectedFrames[startFrame]['fades'].append(fade)
		startFrame += 1


# make a black frame
#commands.getstatusoutput('convert -geometry '+targetSize+' -contrast-stretch 0%x0%  '+frameDir+'/1.jpg '+frameDir+'/0.jpg')

# add
for i, v in selectedFrames.iteritems():
	#selectedFrames[i]['frames'].append( (i, targetFrameDir) )
	#selectedFrames[i]['fades'].append(1)
#	if len(v['frames']) == 0: # if nothing
#		selectedFrames[i]['frames'].append( (i, targetFrameDir) )
#		selectedFrames[i]['fades'].append(1)
	#else: # need to blend frames better...
	summy = float(sum(selectedFrames[i]['fades']))
	if summy > 1:
		for f in range(len(selectedFrames[i]['fades'])): selectedFrames[i]['fades'][f] = selectedFrames[i]['fades'][f]/summy
		#print "OVER", selectedFrames[i]['fades']
	elif summy < 1 and not USE_TARGET_VID: # not enough, add dummy frames
		#print "UNDER", selectedFrames[i]['fades'], 1-summy
		selectedFrames[i]['frames'].append( (int(SILENCE_FRAM_START), frameDir, None) )
		SILENCE_FRAM_START += SILENCE_FRAME_ADVANCE
		selectedFrames[i]['fades'].append(1-summy)
	else: pass
	#print i, selectedFrames[i]


# prep out-frames directory
outDir =  os.path.join(TMP_DIR, 'out-frames/')
if os.path.exists(outDir): shutil.rmtree(outDir)
os.makedirs(outDir)


# mix frames...
for i, dict in selectedFrames.iteritems():
	frameList = dict['frames']
	fadeList = dict['fades']
	srcs = []
	print "frame:", str(i)+'/'+str(durationFrames), '-- found ', len(frameList), 'frame(s)'
	for idx, (frame, file, startsec) in enumerate(frameList):
		path = os.path.join(file, str(frame)+FRAME_EXTENSION)
		if not os.path.exists(path):
			print "ERROR, seek too far in ", file, path
		srcs.append((path, startsec))
		dest = os.path.join(outDir, str(i)+FRAME_EXTENSION)

	#print i, srcs
	if len(srcs) == 1: # just a single frame
		command = 'cp '+srcs[0][0]+' '+dest # link to first frame -- NO SOUND!
		executeCommand(command)
		
	elif VIDEO_FRAME_MIX_METHOD == 'mostRecentSegment': # only take most recently started segment's frame
		srcs.sort(key=lambda x: x[1]) # -1 gives last started
		executeCommand('cp %s %s'%(srcs[-1][0], dest))
		
	else: # mix multiple frames
		while len(srcs) > 1:
			mixer = [srcs[0][0], srcs[0][1]]
			if VIDEO_FRAME_MIX_METHOD == 'composite':
				command = 'convert  '+' '.join(mixer)+' -compose Plus -composite '+dest
			elif VIDEO_FRAME_MIX_METHOD == 'lighten':
				command = 'convert '+' '.join(mixer)+' -compose Lighten -composite '+dest
			elif VIDEO_FRAME_MIX_METHOD == 'overlay':
				command = 'convert '+' '.join(mixer)+' -compose dissolve -define compose:args=50 -gravity South -composite '+dest 
			elif VIDEO_FRAME_MIX_METHOD == 'dissolve':
				tmp = 100./sum(fadeList[0:2])
				blendVal = str(int( (100./sum(fadeList[0:2]))*fadeList[0] ))
				command = 'composite -blend '+blendVal+' -gravity South '+' '.join(srcs[0:2])+' '+dest
			executeCommand(command)
			#executeCommand('open '+dest)
			compositeFade = sum(fadeList[0:2])
			del srcs[0:2]
			del fadeList[0:2]
			srcs.insert(0, (dest, startsec))
			fadeList.insert(0, compositeFade)
			#sys.exit()


# mix frames back to movie		
command = 'ffmpeg -y -r '+str(FR)+' -f image2 -i '+outDir+'%d'+FRAME_EXTENSION+' -q:v 1 /tmp/outputmovie.avi'
executeCommand(command)

if NORMALIZE_TARGET_AUDIO:
	executeCommand('cp ' +targetPath+' /tmp/target.aiff')
	executeCommand('normalize /tmp/target.aiff')
	targetAudio = '/tmp/target.aiff'
	executeCommand('normalize '+AUDIOGUIDE_SF)
	concateAudio = AUDIOGUIDE_SF
else:
	targetAudio = targetPath
	concateAudio = AUDIOGUIDE_SF

if AUDIO_MIX_METHOD == 'target':
	movieAudio = targetAudio
elif AUDIO_MIX_METHOD == 'result':
	movieAudio = concateAudio
elif AUDIO_MIX_METHOD == 'targetAndResult':
	executeCommand('sox -m '+targetAudio+' '+concateAudio+' /tmp/mixed.aiff')
	movieAudio = '/tmp/mixed.aiff'




# for web compression
command = 'ffmpeg -y -i /tmp/outputmovie.avi -i '+movieAudio+' -q:v 1  '+OUTPUT
executeCommand(command)
#executeCommand('open '+OUTPUT)

